#include <stdio.h>
#include <time.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>

#define Maxline 128
#define NULLC (char *)NULL
int main(int argc,char *argv[])
{
	
        pid_t pid;
	int pfd[2];
    	int i, status;
    	char *username;

        int len=Maxline;
	int n;
	FILE *fp,*punt;
	struct tm hra;
	time_t aux,secs;
	char segs[]="date +%s";
	char buff[Maxline];//[]="9:15:04:52:Hola:Chao.";
	char command[Maxline],buffer[Maxline];
	char *delim=":";
	char *puff,*subject,*body;
	char *fecha;
	
	/*
	obtiene el nombre de la persona que ejecuta el programa

        */
    	if ((username = cuserid(NULL)) == NULL)
    	{
        	fprintf(stderr, "QUIEN ERES\n");
        	exit(1);
    	}

	punt=fopen((*++argv),"r");
	
	while(fgets(buff,len,punt)!=NULL)
		//printf("%s\n",buff);
	{
		hra.tm_year=100;
		puff=strtok(buff,delim);
		hra.tm_mon=((atoi(puff))-1);
		puff=strtok(NULL,delim);
		hra.tm_mday=atoi(puff);
		puff=strtok(NULL,delim);
		hra.tm_hour=atoi(puff);
		puff=strtok(NULL,delim);
		hra.tm_min=atoi(puff);
		hra.tm_sec=0;
	//	printf("%d/%d/%d %d:%d:%d",hra.tm_mday,hra.tm_mon,hra.tm_year,hra.tm_hour,hra.tm_min,hra.tm_sec);
		aux=mktime(&hra);
	//	printf("%d\n",aux);
		fecha=ctime(&aux);
	//	printf("%s\n",fecha);
		n=strlen(segs);
		snprintf(command, sizeof(command), "%s", segs);
		fp = popen(command, "r");
		while (fgets(buffer, Maxline, fp) != NULL);
	//		fputs(buffer, stdout);

		pclose(fp);
		//fgets(tsec,len, fp);
		secs=atoi(buffer);
		//pclose(fp);
		sleep(aux-secs);
	        if (username==cuserid(NULL))//Para verificar si es el mismo usuario que corri
	        {                           //el programa.
	        printf("\7");
		printf("\nUsted tiene un nuevo mensaje!\n");;
		sleep(2);
		printf("\7");
		subject=strtok(NULL,delim);
		
	//	while ((body=strtok(NULL,delim))!=NULL);
			//printf("%s\n",body);
	
		if (pipe(pfd) < 0)
		{
        		perror("error creando pipe");
        	exit(1);
    		}

    		/*Crea un hijo.     */
    		if ((pid = fork()) < 0)
    		{
        		perror("error fork");
        		exit(1);
    		}

    		/* el proceso hijo ejecuta el comando mail.     */
    		if (pid == 0) {
        										/*
         		* liga la entraga estandar con el pipe
         		*/
        		dup2(pfd[0], 0);
        		close(pfd[1]);
        		execl("/bin/mail", "mail ", username,"-s",subject, 0);
        		perror("exec");
        		_exit(127);
    		}

    		/* no se va a leer desde la pipe (padre)    */
    		close(pfd[0]);
                body=strtok(NULL,delim);
    		/* se escribe un mensaje a la pipe del hijo     */
    		write(pfd[1],body , strlen(body));
    		//write(pfd[1], "Esta es una prueba\n", 19);
    		//write(pfd[1], ".\n", 5);

    		/*   cierra la pipe     */
    		close(pfd[1]);

    		/*espera a que finalice el hijo*/
    		waitpid(pid, &status, 0);
                }
			
		
	};	
	fclose(punt);
	
	exit(0);
}